unit visionk_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons;

type
  S020_ = string

    [20];

const
  //Couleurs
  ColVert_ = $00C5E2D1;
  ColBleu_ = $00E7D7C9;

  //-
  //Standards
  StandardsMax_ = 60;
  Standards_: array[1..StandardsMax_, 1..3] of S020_ = (
    ('WHUXGA', '7680', '4800'),
    ('WHSXGA', '6400', '4096'),
    ('6K', '6144', '3456'),
    ('WHXGA', '5120', '3200'),
    ('5K', '5120', '2880'),
    ('4K UW', '5120', '2160'),
    ('4K DCI natif', '4096', '2160'),
    ('4K DCI recadré', '4076', '1714'),
    ('4K DCI Flat recadré', '3996', '2160'),
    ('4K UHD', '3840', '2160'),
    ('QUXGA', '3200', '2400'),
    ('WQSXGA', '3200', '2048'),
    ('WQSXGA', '3072', '1920'),
    ('WQSXGA', '2560', '1920'),
    ('WQXGA', '2560', '1600'),
    ('QHD', '2560', '1440'),
    ('QHD', '2304', '1440'),
    ('QHD', '2276', '1707'),
    ('QXGA', '2048', '1536'),
    ('2K', '2048', '1080'),
    ('2K', '1920', '1440'),
    ('WUXGA', '1920', '1200'),
    ('Full HD', '1920', '1080'),
    ('Full HD', '1680', '1650'),
    ('WSXGA +', '1680', '1050'),
    ('UXGA', '1600', '1200'),
    ('UXGA', '1600', '900'),
    ('UXGA', '1536', '960'),
    ('WXGA +', '1440', '900'),
    ('SXGA +', '1400', '1050'),
    ('WXGA (16:9)', '1366', '768'),
    ('SXGA', '1280', '1024'),
    ('SXGA', '1280', '960'),
    ('WXGA (16:10)', '1280', '800'),
    ('HD Ready', '1280', '720'),
    ('HD Ready', '1200', '900'),
    ('XGA +', '1152', '864'),
    ('XGA +', '1152', '720'),
    ('XGA', '1024', '768'),
    ('XGA', '1024', '576'),
    ('XGA', '960', '720'),
    ('XGA', '960', '600'),
    ('XGA', '854', '480'),
    ('XGA', '848', '480'),
    ('SVGA', '800', '600'),
    ('SVGA', '800', '480'),
    ('PAL', '768', '576'),
    ('PAL', '768', '480'),
    ('DVD', '720', '576'),
    ('VGA', '640', '480'),
    ('VGA', '640', '400'),
    ('VGA', '640', '360'),
    ('VGA', '576', '360'),
    ('VGA', '480', '360'),
    ('VGA', '480', '300'),
    ('VGA', '400', '300'),
    ('VGA', '384', '240'),
    ('HVGA', '320', '480'),
    ('QVGA', '320', '240'),
    ('CGA', '320', '200')
    );
  //-
  ConvertMax_ = 39;
  //Diagonale (pouces), Diagonale (cm), Format, Larg.xHaut.
  Convert_: array[1..ConvertMax_, 1..4] of S020_ = (
    ('85"', '215,9 cm', '16/9', '188,2 x 105,8 cm'),
    ('80"', '203,2 cm', '16/9', '177,1 x  99,6 cm'),
    ('75"', '190,5 cm', '16/9', '166 x 93,4 cm'),
    ('70"', '177,8 cm', '16/9', '155 x 87,2 cm'),
    ('65"', '165,1 cm', '16/9', '143,9 x 80,9 cm'),
    ('60"', '152,4 cm', '16/9', '132,8 x 74,7 cm'),
    ('55"', '139,7 cm', '16/9', '121,8 x 68,5 cm'),
    ('50"', '127 cm',   '16/9', '110,7 x 62,3 cm'),
    ('47"', '119,4 cm', '16/9', '104 x 58,5 cm'),
    ('46"', '116,8 cm', '16/9', '101,8 x 57,3 cm'),
    ('42"', '106,7 cm', '16/9', '93 x 52,3 cm'),
    ('40"', '101,6 cm', '16/9', '88,6 x 49,8 cm'),
    ('39"', '99,1 cm', '16/9', '86,3 x 48,6 cm'),
    ('32"', '81,3 cm', '16/9', '70,8 x 39,8 cm'),
    ('30"', '76,2 cm', '16/9', '66,4 x 37,4 cm'),
    ('28"', '71,1 cm', '16/9', '62 x 34,9 cm'),
    ('26"', '66 cm', '16/9', '57,6 x 32,4 cm'),
    ('24"', '61 cm', '16/9', '53,1 x 29,9 cm'),
    ('22"', '55,9 cm', '4/3', '44,7 x 33,5 cm'),
    ('22"', '55,9 cm', '16/9', '48,7 x 27,4 cm'),
    ('19"', '48,3 cm', '4/3', '38,6 x 29 cm'),
    ('19"', '48,3 cm', '16/9', '42,1 x 23,7 cm'),
    ('17"', '43,2 cm', '4/3', '34,5 x 25,9 cm'),
    ('17"', '43,2 cm', '16/9', '37,6 x 21,2 cm'),
    ('15"', '38,1 cm', '4/3', '30,5 x 22,9 cm'),
    ('15"', '38,1 cm', '16/9', '33,2 x 18,7 cm'),
    ('14"', '35,6 cm', '4/3', '28,4 x 21,3 cm'),
    ('14"', '35,6 cm', '16/9', '31 x 17,4 cm'),
    ('12"', '30,5 cm', '16/9', '26,6 x 14,9 cm'),
    ('10"', '25,4 cm', '16/9', '22,1 x 12,5 cm'),
    ('9"', '22,9 cm', '16/9', '19,9 x 11,2 cm'),
    ('8"', '20,3 cm', '16/9', '17,7 x 10 cm'),
    ('7"', '17,8 cm', '16/9', '15,5 x 8,7 cm'),
    ('6"', '15,2 cm', '16/9', '13,3 x 7,5 cm'),
    ('5"', '12,7 cm', '16/9', '11,1 x 6,2 cm'),
    ('4"', '10,2 cm', '16/9', '8,9 x 5 cm'),
    ('3,5"', '7,5 cm', '16/10', '7,5 x 4,7 cm'),
    ('3,5"', '8,9 cm', '16/9', '7,7 x 4,4 cm'),
    ('0"', '0', '0', '0')
    );

type

  { TWdMain }

  TWdMain = class(TForm)
    EdDesign: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    EdLa: TEdit;
    EdHa: TEdit;
    EdDiag1: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Img1: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    PaLa: TPanel;
    PaDpi: TPanel;
    PaRap: TPanel;
    PaPitch: TPanel;
    PnHa: TPanel;
    Panel1: TPanel;
    PaDist1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    PaDist2: TPanel;
    PaDiag: TPanel;
    PaPo: TPanel;
    SpeedButton1: TSpeedButton;
    procedure EdDiag1Change(Sender: TObject);
    procedure EdHaChange(Sender: TObject);
    procedure EdLaChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;
  //Ecran
  MaxX, MaxY: integer;

implementation

{$R *.lfm}

{ TWdMain }

//Real en String, 2 décimales
function RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //max 15 décimales
  Result := s;
end;

function StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

function TAN(x: real): real; //Argument en radians
begin
  TAN := Sin(x) * (1 / Cos(x));
end;

function Format32(s: S020_; l: integer): S020_;
var
  t: S020_;
begin
  t := s;
  if Length(t) < l then
  begin
    repeat
      t := t + ' ';
    until Length(t) >= l;
  end;
  Result := t;
end;

function Virgule(s: string): string;
var
  n: integer;
  t: string;
begin
  if s = '' then
    s := '0';
  t := s;
  for n := 1 to Length(s) do
    if t[n] = ',' then
      t[n] := '.';
  Result := t;
end;

function IfChiffre(s: string): boolean;
var
  n, Chiffres: integer;
  Separateurs: integer;
  Ok: boolean;
begin
  Ok := False;
  if s <> '' then
  begin
    Chiffres := 0;
    Separateurs := 0;
    //0..9 et . ou ,
    for n := 1 to Length(s) do
    begin
      //0..9
      if s[n] in ['0'..'9'] then
        Inc(Chiffres);
      //. ou ,
      if s[n] in ['.', ','] then
        Inc(Separateurs);
    end;
    if (Separateurs = 0) or (Separateurs = 1) then
    begin
      if Chiffres + Separateurs = Length(s) then
        Ok := True;
    end;
  end;
  Result := Ok;
end;

procedure Standards(Select, Emplacement: integer);
begin
  with WdMain do
  begin
    //Nom
    EdDesign.Text := Standards_[Emplacement, 1];
    case Select of
      1: EdDesign.Color := ClWhite;
      2: EdDesign.Color := ColBleu_;
    end;
    //Longueur
    EdLa.Text := Standards_[Emplacement, 2];
    //Hauteur
    EdHa.Text := Standards_[Emplacement, 3];
  end;
end;

procedure Init;
var
  n: integer;
begin
  with WdMain do
  begin
    //taille écran
    MaxX := Screen.Width;
    MaxY := Screen.Height;
    Edit10.Text := IntToStr(MaxX);
    Edit11.Text := IntToStr(MaxY);
    //Standards
    ListBox1.Items.Clear;
    for n := 1 to StandardsMax_ do
    begin
      ListBox1.Items.Add(Standards_[n, 1] + ' ' + Standards_[n, 2] +
        ' ' + Standards_[n, 3]);
    end;
    //Convert
    ListBox2.Items.Clear;
    for n := 1 to ConvertMax_ do
    begin
      ListBox2.Items.Add(
        Format32(Convert_[n, 1], 6) + Format32(Convert_[n, 2], 10) +
        Format32(Convert_[n, 3],6) + ' ' + Convert_[n, 4]);
    end;
  end;
end;

procedure Recherche_Format;
var
  L, H: S020_;
  n: integer;
  Ok: boolean;
begin
  with WdMain do
  begin
    EdDiag1.Text := '0';
    L := IntToStr(MaxX);
    H := IntToStr(MaxY);
    Ok := False;
    n := 1;
    repeat
      if (Standards_[n, 2] = L) and (Standards_[n, 3] = H) then
      begin
        Ok := True;
        ListBox1.ItemIndex := n - 1;
        Standards(2, ListBox1.ItemIndex + 1);
      end;
      Inc(n);
    until (Ok) or (n > StandardsMax_);
  end;
end;

procedure Recherche_Dimension(Diag: S020_);
var
  s: S020_;
  n: integer;
  Ok: boolean;
begin
  with WdMain do
  begin
    if Diag = '' then
      Diag := '0';
    Ok := False;
    n := 1;
    repeat
      s := Copy(Convert_[n, 1], 1, Length(Convert_[n, 1]) - 1);
      if s = Diag then
      begin
        Ok := True;
        ListBox2.ItemIndex := n - 1;
      end;
      Inc(n);
    until (Ok) or (n > ConvertMax_);
  end;
end;

procedure Calcul;
var
  La, Ha, Di, Ra: string;
  LongueurCm, HauteurCm: real;
  LongueurPix, HauteurPix: real;
  Rapport, Poids, DPI: real;
  DistanceMini1: real;
  DistanceMini2: real;
  DiagCm, DiagPouces: real;
  DiagPixels, Pitch: real;
  Angle: real;
begin
  //On peut percevoir 60 pixels par degré
  //car la résolution de l'oeil est de 1 mn d'arc
  //Et comme 1 degré fait 60 mn d'arc...
  //exemple :
  //Si un écran fait 1080 pixels de haut,
  //1080/60=18°. Il faut que l'angle fasse 18°
  //et donc, la distance = Tangante-1(18)=H/L
  //Tg-1(18)=H/L -> L=H/0,3249
  //L=0,58/0,3249=1,785 metres
  //-
  //61 cm  1920 x 1080  Full HD
  //61 cm / 2,54 = 24,01574803149606 pouces
  with WdMain do
  begin
    //Largueur
    La := Virgule(EdLa.Text);
    EdLa.Text := La;
    if IfChiffre(La) then
    begin
      LongueurPix := StrToReal(La);
      //Hauteur
      Ha := Virgule(EdHa.Text);
      EdHa.Text := Ha;
      if IfChiffre(Ha) then
      begin
        HauteurPix := StrToReal(Ha);
        //Calcul du Poids
        Poids := LongueurPix * HauteurPix;
        if Poids > 1000000 then
          PaPo.Caption := RealToStr(Poids / 1000000, 6) + ' Mp'
        else
          PaPo.Caption := RealToStr(Poids, 0) + ' p';
        //Calcul du Rapport
        Rapport := 0;
        if HauteurPix > 0 then
          Rapport := LongueurPix / HauteurPix;
        Ra := RealToStr(Rapport, 4);
        PaRap.Caption := Ra;
        //Couleur pour Ra=1,3 => 4:3
        if Copy(Ra, 1, 3) = '1.3' then
        begin
          PaRap.Color := ClYellow;
        end
        else
        begin
          //Couleur pour Ra=1,7 => 16:9
          if Copy(Ra, 1, 3) = '1.7' then
          begin
            PaRap.Color := ClLime;
          end
          else
          begin
            //Couleur pour Ra=2,3 => 21:9
            if Copy(Ra, 1, 3) = '2.3' then
            begin
              PaRap.Color := ClAqua;
            end
            else
            begin
              PaRap.Color := ClWhite;
            end;
          end;
        end;
        //Récup. de la Diagonale
        Di := Virgule(EdDiag1.Text);
        if Di = '0' then
          EdDiag1.Text := ''
        else
          EdDiag1.Text := Di;
        if IfChiffre(Di) then
        begin
          //1 cm = 0.393700787 pouces
          //1 pouce = 2.54 cm
          //Affiche Diagonale en cm
          DiagPouces := StrToReal(Di);
          DiagCm := DiagPouces * 2.54;
          PaDiag.Caption := RealToStr(DiagCm, 4) + ' cm';
          //Calcul DPI, PITCH, Distance Mini
          DPI := 0;
          if DiagPouces > 0 then
          begin
            //Nb pixels sur diagonale
            DiagPixels := Sqrt((LongueurPix * LongueurPix) + (HauteurPix * HauteurPix));
            //DPI=Nb Points diag. / Diag. en Pouces
            DPI := DiagPixels / DiagPouces;
            PaDpi.Caption := RealToStr(DPI, 4);
            //-
            //Longueur écran = Racine ((Diagonale²)/(1+1/Rapport²))
            //H=racine(D²/(k²+1) avec k=16/9
            LongueurCm := Sqrt((DiagCm * DiagCm) / (1 + 1 / (Rapport * Rapport)));
            PaLa.Caption := RealToStr(LongueurCM, 4) + ' cm';
            //-
            //Hauteur écran = Racine ((Diagonale²)/(Rapport²+1))
            //L=racine(D²/(1/k²+1)) avec k=16/9
            HauteurCm := Sqrt((DiagCm * DiagCm) / ((Rapport * Rapport) + 1));
            PnHa.Caption := RealtoStr(HauteurCm, 4) + ' cm';
            //-
            //Pitch = Longueur ecran mm / Nb Pixels Longueur
            Pitch := (LongueurCm * 10) / LongueurPix;
            PaPitch.Caption := RealToStr(Pitch, 4);
            //-
            //Distance mini (Entre oeil et écran)
            //Distance Mini = (Pitch * 3000)/10 (en cm)
            DistanceMini1 := (Pitch * 3000) / 10;
            PaDist1.Caption := RealToStr(DistanceMini1, 4) + ' cm';
            //3000*Sqrt(HauteurPix²*DiagCm²/(Rapport²))/HauteurPix (en cm).
            //-
            //Distance mini par la méthode des 60 pixels / °
            //Angle en °
            Angle := HauteurPix / 60;
            DistanceMini2 := HauteurCm / Tan(Angle * (PI / 180));
            PaDist2.Caption := RealToStr(DistanceMini2, 4) + ' cm';
          end
          else
          begin
            PaDpi.Caption := '0';
            PnHa.Caption := '0';
            PaPitch.Caption := '0';
            PaDist1.Caption := '0';
            PaDist2.Caption := '0';
          end;
        end;
      end;
    end;
    ActiveControl := EdDiag1;
  end;
end;

procedure Affiche_Points;
var
  Col: TColor;
  Xm, Ym: integer;
  x, y: integer;
begin
  with WdMain do
  begin
    Xm := Img1.Width;
    Ym := Img1.Height;
    with Img1.Canvas do
    begin
      Pen.Color := ClWhite;
      //Clear
      for x := 0 to Xm - 1 do
        Line(x, 0, x, Ym - 1);
      //Entre points : 3
      x := 20;
      repeat
        for y := 11 to 17 do
          Pixels[x, y] := ClBlack;
        Inc(x, 4);
      until x > Xm - 20;
      //Entre points : 2
      x := 20;
      repeat
        for y := 31 to 37 do
          Pixels[x, y] := ClBlack;
        Inc(x, 3);
      until x > Xm - 20;
      //Entre points : 1
      col := $00858585;
      x := 20;
      repeat
        for y := 51 to 57 do
          Pixels[x, y] := Col;
        if Col = clblack then
          Col := $00858585
        else
          Col := ClBlack;
        Inc(x);
      until x > Xm - 20;
    end;
  end;
end;

procedure TWdMain.ListBox1Click(Sender: TObject);
begin
  Standards(1, ListBox1.ItemIndex + 1);
  Recherche_Dimension(EdDiag1.Text);
  Calcul;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Recherche_Format;
  Recherche_Dimension('0');
  Calcul;
end;

procedure TWdMain.EdDiag1Change(Sender: TObject);
begin
  Recherche_Dimension(EdDiag1.Text);
  Calcul;
end;

procedure TWdMain.EdHaChange(Sender: TObject);
begin
  Calcul;
end;

procedure TWdMain.EdLaChange(Sender: TObject);
begin
  Calcul;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  Init;
  Recherche_Format;
  Affiche_Points;
  ListBox2.ItemIndex := 0;
  ActiveControl := EdDiag1;
end;

end.
